#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_shop.h"
#include "FileEncrypt.h"
std::auto_ptr<M_shop> M_shop::msSingleton(nullptr);

int M_shop::GetCount()
{
	return (int)mMapData.size();
}

const M_shopData* M_shop::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_shopData>& M_shop::GetMapData()
{
	return mMapData;
}

void M_shop::Reload()
{
	mMapData.clear();
	Load();
}

void M_shop::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_shopData data;
		data.mID = element->IntAttribute("ID");
		data.mshop_type = element->IntAttribute("shop_type");
		{
			const char* cost_Item = element->Attribute("cost_Item");
			std::vector<std::string> veccost_Item;
			boost::split(veccost_Item, cost_Item, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < veccost_Item.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(veccost_Item[i].c_str(), &temp))
				{
					data.mcost_Item.push_back(temp);
				}
			}
		}
		{
			const char* reward = element->Attribute("reward");
			std::vector<std::string> vecreward;
			boost::split(vecreward, reward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecreward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecreward[i].c_str(), &temp))
				{
					data.mreward.push_back(temp);
				}
			}
		}
		data.micon = element->Attribute("icon");
		data.msort = element->IntAttribute("sort");
		data.mcondition = element->IntAttribute("condition");
		data.mvalue = element->Attribute("value");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_shop::Load()
{
	Load("../Config/M_shop.xml");
}

M_shop* M_shop::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_shop());
	}
	return msSingleton.get();
}
